diff --git a/Documentation/kernel-parameters.txt b/Documentation/kernel-parameters.txt
index d77fbd8..097ea9f 100644
--- a/Documentation/kernel-parameters.txt
+++ b/Documentation/kernel-parameters.txt
@@ -57,6 +57,7 @@ parameter is applicable:
 	ISAPNP	ISA PnP code is enabled.
 	ISDN	Appropriate ISDN support is enabled.
 	JOY	Appropriate joystick support is enabled.
+	KVM	Kernel Virtual Machine support is enabled.
 	LIBATA  Libata driver is enabled
 	LP	Printer support is enabled.
 	LOOP	Loopback device support is enabled.
@@ -409,6 +410,9 @@ and is between 256 and 4096 characters. It is defined in the file
 			See drivers/scsi/BusLogic.c, comment before function
 			BusLogic_ParseDriverOptions().
 
+	bypass_guest_pf=[KVM,Intel] Disables bypassing of guest page faults
+			on Intel chips. Default is 1 (enabled)
+
 	c101=		[NET] Moxa C101 synchronous serial card
 
 	cachesize=	[BUGS=X86-32] Override level 2 CPU cache size detection.
@@ -708,6 +712,10 @@ and is between 256 and 4096 characters. It is defined in the file
 			pass this option to capture kernel.
 			See Documentation/kdump/kdump.txt for details.
 
+	emulate_invalid_guest_state=
+			[KVM,Intel] Enable emulation of invalid guest states
+			Default is 0 (disabled)
+
 	enable_mtrr_cleanup [X86]
 			The kernel tries to adjust MTRR layout from continuous
 			to discrete, to make X server driver able to add WB
@@ -719,6 +727,15 @@ and is between 256 and 4096 characters. It is defined in the file
 			(in particular on some ATI chipsets).
 			The kernel tries to set a reasonable default.
 
+	enable_unrestricted_guest=
+			[KVM,Intel] Disable unrestricted guest feature
+			(virtualized real and unpaged mode) on capable
+			Intel chips. Default is 1 (enabled)
+
+	enable_vpid=	[KVM,Intel] Disable Virtual Processor Identification
+			feature (tagged TLBs) on capable Intel chips.
+			Default is 1 (enabled)
+
 	enforcing	[SELINUX] Set initial enforcing status.
 			Format: {"0" | "1"}
 			See security/selinux/Kconfig help text.
@@ -727,6 +744,10 @@ and is between 256 and 4096 characters. It is defined in the file
 			Default value is 0.
 			Value can be changed at runtime via /selinux/enforce.
 
+	enable_ept=	[KVM,Intel] Disable extended page tables
+			(virtualized MMU) support on capable Intel chips.
+			Default is 1 (enabled)
+
 	ether=		[HW,NET] Ethernet cards parameters
 			This option is obsoleted by the "netdev=" option, which
 			has equivalent usage. See its documentation for details.
@@ -747,6 +768,10 @@ and is between 256 and 4096 characters. It is defined in the file
 	fdomain=	[HW,SCSI]
 			See header of drivers/scsi/fdomain.c.
 
+	flexpriority_enabled=
+			[KVM,Intel] Disable FlexPriority feature (TPR shadow).
+			Default is 1 (enabled)
+
 	floppy=		[HW]
 			See Documentation/blockdev/floppy.txt.
 
@@ -923,6 +948,9 @@ and is between 256 and 4096 characters. It is defined in the file
 			Ignore loglevel setting - this will print /all/
 			kernel messages to the console. Useful for debugging.
 
+	ignore_msrs=	[KVM] Ignore guest accesses to unhandled MSRs.
+			Default is 0 (don't ignore, but inject #GP)
+
 	ihash_entries=	[KNL]
 			Set number of hash buckets for inode cache.
 
@@ -1475,6 +1503,9 @@ and is between 256 and 4096 characters. It is defined in the file
 
 	ncr53c8xx=	[HW,SCSI]
 
+	nested=		[KVM,AMD] Allow nested virtualization in KVM/SVM.
+			Default is 0 (off)
+
 	netdev=		[NET] Network devices parameters
 			Format: <irq>,<io>,<mem_start>,<mem_end>,<name>
 			Note that mem_start is often overloaded to mean
@@ -1689,6 +1720,10 @@ and is between 256 and 4096 characters. It is defined in the file
 
 	nox2apic	[X86-64,APIC] Do not enable x2APIC mode.
 
+	npt=		[KVM,AMD] Disable nested paging (virtualized MMU)
+			for all guests.
+			Default is 1 (enabled) if in 64bit or 32bit-PAE mode
+
 	nptcg=		[IA64] Override max number of concurrent global TLB
 			purges which is reported from either PAL_VM_SUMMARY or
 			SAL PALO.
@@ -1711,6 +1746,9 @@ and is between 256 and 4096 characters. It is defined in the file
 			waiting for the ACK, so if this is set too high
 			interrupts *may* be lost!
 
+	oos_shadow=	[KVM] Disable out-of-sync shadow paging.
+			Default is 1 (enabled)
+
 	opl3=		[HW,OSS]
 			Format: <io>
 